package org.jeecg.modules.system.app.controller;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.SecurityUtils;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.modules.system.app.entity.ShopMoney;
import org.jeecg.modules.system.app.service.IShopMoneyService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Arrays;
 /**
 * @Description: 店铺资金总数
 * @Author: jeecg-boot
 * @Date:   2025-08-18
 * @Version: V1.0
 */
@Tag(name="店铺资金总数")
@RestController
@RequestMapping("/shopMoney/shopMoney")
@Slf4j
public class ShopMoneyController extends JeecgController<ShopMoney, IShopMoneyService> {
	@Autowired
	private IShopMoneyService shopMoneyService;
	
	/**
	 * 分页列表查询
	 *
	 * @param shopMoney
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "店铺资金总数-分页列表查询")
	@Operation(summary="店铺资金总数-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<ShopMoney>> queryPageList(ShopMoney shopMoney,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {


		Page<ShopMoney> page = new Page<ShopMoney>(pageNo, pageSize);
		IPage<ShopMoney> pageList = shopMoneyService.findPage(page, shopMoney);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param shopMoney
	 * @return
	 */
	@AutoLog(value = "店铺资金总数-添加")
	@Operation(summary="店铺资金总数-添加")
	@RequiresPermissions("shopMoney:nm_shop_money:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody ShopMoney shopMoney) {
		shopMoneyService.save(shopMoney);

		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param shopMoney
	 * @return
	 */
	@AutoLog(value = "店铺资金总数-编辑")
	@Operation(summary="店铺资金总数-编辑")
	@RequiresPermissions("shopMoney:nm_shop_money:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody ShopMoney shopMoney) {
		shopMoneyService.updateById(shopMoney);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "店铺资金总数-通过id删除")
	@Operation(summary="店铺资金总数-通过id删除")
	@RequiresPermissions("shopMoney:nm_shop_money:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		shopMoneyService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "店铺资金总数-批量删除")
	@Operation(summary="店铺资金总数-批量删除")
	@RequiresPermissions("shopMoney:nm_shop_money:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.shopMoneyService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "店铺资金总数-通过id查询")
	@Operation(summary="店铺资金总数-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<ShopMoney> queryById(@RequestParam(name="id",required=true) String id) {
		ShopMoney shopMoney = shopMoneyService.getById(id);
		if(shopMoney==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(shopMoney);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param shopMoney
    */
    @RequiresPermissions("shopMoney:nm_shop_money:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, ShopMoney shopMoney) {
        return super.exportXls(request, shopMoney, ShopMoney.class, "店铺资金总数");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("shopMoney:nm_shop_money:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, ShopMoney.class);
    }

	 /**
	  * 通过orgCode查询
	  *
	  * @return
	  */
	 //@AutoLog(value = "店铺资金总数-通过id查询")
	 @Operation(summary="店铺资金总数-通过id查询")
	 @GetMapping(value = "/queryByCode")
	 public Result<ShopMoney> queryByCode() {
		 LoginUser loginUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
		 ShopMoney shopMoney = shopMoneyService.findByOrgCode(loginUser.getOrgCode());
		 if(shopMoney==null) {
			 return Result.error("未找到对应数据");
		 }
		 return Result.OK(shopMoney);
	 }

}
